Index: /trunk/src/sh_suidchk.c
===================================================================
--- /trunk/src/sh_suidchk.c	(revision 584)
+++ /trunk/src/sh_suidchk.c	(revision 1)
@@ -1987,87 +1429,35 @@
   switch (t)
     {
-#ifdef MOUNT_UFS
     case MOUNT_UFS:
       return _("ufs");
+    case MOUNT_NFS:
+      return _("nfs");
+#ifdef MOUNT_PC
+    case MOUNT_PC:
+      return _("pc");
+#endif
+#ifdef MOUNT_MFS
+    case MOUNT_MFS:
+      return _("mfs");
+#endif
+#ifdef MOUNT_LO
+    case MOUNT_LO:
+      return _("lofs");
+#endif
+#ifdef MOUNT_TFS
+    case MOUNT_TFS:
+      return _("tfs");
+#endif
+#ifdef MOUNT_TMP
+    case MOUNT_TMP:
+      return _("tmp");
+#endif
+#ifdef MOUNT_MSDOS
+    case MOUNT_MSDOS:
+      return _("msdos");
 #endif
 #ifdef MOUNT_ISO9660
     case MOUNT_ISO9660:
       return _("iso9660fs");
-#endif
-#ifdef MOUNT_CD9660
-    case MOUNT_CD9660:
-      return _("cd9660");
-#endif
-#ifdef MOUNT_NFS
-    case MOUNT_NFS:
-      return _("nfs");
-#endif
-#ifdef MOUNT_PC
-    case MOUNT_PC:
-      return _("pc");
-#endif
-#ifdef MOUNT_MFS
-    case MOUNT_MFS:
-      return _("mfs");
-#endif
-#ifdef MOUNT_LO
-    case MOUNT_LO:
-      return _("lofs");
-#endif
-#ifdef MOUNT_TFS
-    case MOUNT_TFS:
-      return _("tfs");
-#endif
-#ifdef MOUNT_TMP
-    case MOUNT_TMP:
-      return _("tmp");
-#endif
-#ifdef MOUNT_MSDOS
-    case MOUNT_MSDOS:
-      return _("msdos");
-#endif
-#ifdef MOUNT_LFS
-    case MOUNT_LFS:
-      return _("lfs");
-#endif
-#ifdef MOUNT_LOFS
-    case MOUNT_LOFS:
-      return _("lofs");
-#endif
-#ifdef MOUNT_FDESC
-    case MOUNT_FDESC:
-      return _("fdesc");
-#endif
-#ifdef MOUNT_PORTAL
-    case MOUNT_PORTAL:
-      return _("portal");
-#endif
-#ifdef MOUNT_NULL
-    case MOUNT_NULL:
-      return _("null");
-#endif
-#ifdef MOUNT_UMAP
-    case MOUNT_UMAP:
-      return _("umap");
-#endif
-#ifdef MOUNT_KERNFS
-    case MOUNT_KERNFS:
-      return _("kernfs");
-#endif
-#ifdef MOUNT_PROCFS
-    case MOUNT_PROCFS:
-      return _("procfs");
-#endif
-#ifdef MOUNT_DEVFS
-    case MOUNT_DEVFS:
-      return _("devfs");
-#endif
-#ifdef MOUNT_EXT2FS
-    case MOUNT_EXT2FS:
-      return _("ext2fs");
-#endif
-#ifdef MOUNT_UNION
-    case MOUNT_UNION:
-      return _("union");
 #endif
     default:
@@ -2207,5 +1597,4 @@
   current_dev = statp->st_dev;
   current_fstype = filesystem_type_uncached (path, relpath, statp);
-  
   return current_fstype;
 }
@@ -2215,6 +1604,4 @@
    RELPATH is the file name relative to the current directory.
    Return "unknown" if its filesystem type is unknown.  */
-
-void * sh_dummy_2229_type;
 
 static char *
@@ -2229,14 +1616,9 @@
 #endif
 
-#ifdef FSTYPE_MNTENT		/* 4.3BSD, SunOS, HP-UX, Dynix, Irix,Linux  */
+#ifdef FSTYPE_MNTENT		/* 4.3BSD, SunOS, HP-UX, Dynix, Irix.  */
   char *table = MOUNTED;
   FILE *mfp;
   struct mntent *mnt;
 
-  /* Take the address to keep gcc from putting it into a register. 
-   * Avoids the 'clobbered by longjmp' warning. 
-   */
-  sh_dummy_2229_type = (void *) &type;
-
   if (path == NULL || relpath == NULL)
     return NULL;
@@ -2245,9 +1627,7 @@
   if (mfp == NULL)
     {
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN,
 		       _("setmntent() failed"),
 		       _("filesystem_type_uncached") );
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
       return NULL;
     }
@@ -2257,5 +1637,5 @@
   while (type == NULL && (mnt = getmntent (mfp)) != NULL)
     {
-      const char *devopt;
+      char *devopt;
       dev_t dev;
       struct stat disk_stats;
@@ -2288,23 +1668,8 @@
 	  if (stat (mnt->mnt_dir, &disk_stats) == -1)
 	    {
-	      char errmsg[256];
-	      volatile int  elevel = SH_ERR_ERR;
-	      size_t tlen = strlen(mnt->mnt_dir);
-	      
-	      if (tlen >= 6 && 0 == strcmp(&((mnt->mnt_dir)[tlen-6]), _("/.gvfs")))
-		elevel = SH_ERR_NOTICE;
-	      else if (tlen >= 5 && 0 == strcmp(&((mnt->mnt_dir)[tlen-5]), _("/gvfs")))
-		elevel = SH_ERR_NOTICE;
-	      else if (0 == strcmp (mnt->mnt_type, _("tracefs")))
-		elevel = SH_ERR_NOTICE;
-	      
-	      sl_snprintf(errmsg, sizeof(errmsg), _("stat(%s) failed"),
-			  mnt->mnt_dir);
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
-	      sh_error_handle (elevel, FIL__, __LINE__, 0, MSG_E_SUBGEN,
-			       errmsg,
+	      sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN,
+			       _("stat() failed"),
 			       _("filesystem_type_uncached") );
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	      continue;
+	      return NULL;
 	    }
 	  dev = disk_stats.st_dev;
@@ -2315,12 +1680,8 @@
 	  /* check for the "nosuid" option
 	   */
-#ifdef HAVE_HASMNTOPT
-	  if (NULL == hasmntopt(mnt, "nosuid") || (ShSuidchkNosuid == S_TRUE))
+	  if (NULL == hasmntopt(mnt, "nosuid"))
 	    type = mnt->mnt_type;
 	  else
-	    type = _("nosuid"); /* hasmntopt (nosuid) */
-#else
-	  type = mnt->mnt_type;
-#endif
+	    type = _("nosuid");
 	}
     }
@@ -2328,9 +1689,7 @@
   if (endmntent (mfp) == 0)
     {
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN,
 		       _("endmntent() failed"),
 		       _("filesystem_type_uncached") );
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
     }
 #endif
@@ -2343,9 +1702,4 @@
     return NULL;
 
-  /* Take the address to keep gcc from putting it into a register. 
-   * Avoids the 'clobbered by longjmp' warning. 
-   */
-  sh_dummy_2229_type = (void*) &type;
-
   while (type == NULL
 	 && getmnt (&offset, &fsd, sizeof (fsd), NOSTAT_MANY, 0) > 0)
@@ -2363,9 +1717,4 @@
     return NULL;
 
-  /* Take the address to keep gcc from putting it into a register. 
-   * Avoids the 'clobbered by longjmp' warning. 
-   */
-  sh_dummy_2229_type = (void*) &type;
-
   if (statfs (relpath, &fss, sizeof (struct statfs), 0) == -1)
     {
@@ -2373,9 +1722,7 @@
       if (errno != ENOENT)
 	{
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, errno, MSG_E_SUBGEN,
 			   _("statfs() failed"),
 			   _("filesystem_type_uncached") );
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
 	  return NULL;
 	}
@@ -2390,9 +1737,4 @@
   if (path == NULL || relpath == NULL)
     return NULL;
-
-  /* Take the address to keep gcc from putting it into a register. 
-   * Avoids the 'clobbered by longjmp' warning. 
-   */
-  sh_dummy_2229_type = (void*) &type;
 
   if (statvfs (relpath, &fss) == -1)
@@ -2401,9 +1743,7 @@
       if (errno != ENOENT)
 	{
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, errno, MSG_E_SUBGEN,
 			   _("statvfs() failed"),
 			   _("filesystem_type_uncached") );
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
 	  return NULL;
 	}
@@ -2415,5 +1755,5 @@
        /* patch by Konstantin Khrooschev <nathoo@co.ru> 
 	*/
-       if( (fss.f_flag & ST_NOSUID)  && (ShSuidchkNosuid == S_FALSE))
+       if( fss.f_flag & ST_NOSUID )
          type = _("nosuid");
     }
@@ -2432,9 +1772,4 @@
     return NULL;
 
-  /* Take the address to keep gcc from putting it into a register. 
-   * Avoids the 'clobbered by longjmp' warning. 
-   */
-  sh_dummy_2229_type = (void*) &type;
-
   if (S_ISLNK (statp->st_mode))
     p = sh_dirname (relpath);
@@ -2448,9 +1783,7 @@
       if (errno != ENOENT)
 	{
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, errno, MSG_E_SUBGEN,
 			   _("statfs() failed"),
 			   _("filesystem_type_uncached") );
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
 	  return NULL;
 	}
@@ -2472,7 +1805,7 @@
 #ifdef MNT_VISFLAGMASK
       flags = fss.f_flags & MNT_VISFLAGMASK;
-      if ((flags & MNT_NOSUID) && (ShSuidchkNosuid == S_FALSE))
+      if (flags & MNT_NOSUID)
 #else 
-      if ((fss.f_flags & MNT_NOSUID) && (ShSuidchkNosuid == S_FALSE)) 
+      if (fss.f_flags & MNT_NOSUID) 
 #endif
          type = _("nosuid");
@@ -2502,5 +1835,5 @@
 static int
 xatoi (cp)
-     const char *cp;
+     char *cp;
 {
   int val;
Index: /trunk/src/sh_tiger0.c
===================================================================
--- /trunk/src/sh_tiger0.c	(revision 584)
+++ /trunk/src/sh_tiger0.c	(revision 1)
@@ -24,16 +24,10 @@
 #include "sh_error.h"
 #include "sh_utils.h"
-#include "sh_pthread.h"
-#include "sh_string.h"
-
-#define PRIV_MAX  32768
-
-#if defined(TIGER_64_BIT)
+
+#if defined(HAVE_LONG_64) || defined(HAVE_LONG_LONG_64)
 #if defined(HAVE_LONG_64)
 typedef unsigned long int word64;
-#elif defined(HAVE_LONG_LONG_64)
+#else
 typedef unsigned long long int word64;
-#else
-#error No 64 bit type found !
 #endif
 #endif
@@ -52,27 +46,16 @@
 #define GPGFORMAT (_("%08X %08X %08X  %08X %08X %08X"))
 #else
-#error No 32 bit type found !
-#endif
-
-#if defined(__GNUC__) && (__GNUC__ >= 3)
-#undef  SH_GNUC_ALIGN8
-#define SH_GNUC_ALIGN8   __attribute__((aligned(8)))
-#else
-#undef  SH_GNUC_ALIGN8
-#define SH_GNUC_ALIGN8
-#endif
-
+#error No 32 byte type found !
+#endif
 
 typedef unsigned char sh_byte;
-
-#define SH_KEY_NULL _("000000000000000000000000000000000000000000000000")
 
 #undef  FIL__
 #define FIL__  _("sh_tiger0.c")
 
-#if defined(TIGER_64_BIT)
-
-void tiger_t(const word64 *str, word64 length, word64 * res);
-void tiger(const word64 *str, word64 length, word64 * res);
+#if defined(HAVE_LONG_64) || defined(HAVE_LONG_LONG_64)
+/* #ifdef HAVE_LONG_64 */
+void tiger_t(word64 *str, word64 length, word64 * res);
+void tiger(word64 *str, word64 length, word64 * res);
 
 #ifdef TIGER_DBG
@@ -84,6 +67,6 @@
 #endif
 #else
-void tiger(const sh_word32 *str, sh_word32 length, sh_word32 * res);
-void tiger_t(const sh_word32 *str, sh_word32 length, sh_word32 * res);
+void tiger(sh_word32 *str, sh_word32 length, sh_word32 * res);
+void tiger_t(sh_word32 *str, sh_word32 length, sh_word32 * res);
 
 #ifdef TIGER_DBG
@@ -110,28 +93,26 @@
  * implementation
  */
-
-/* static sh_byte buffer[PRIV_MAX + 72]; */
-
-#if defined(TIGER_64_BIT)
+SL_TICKET tiger_fd = (-1);
+
+
+#if defined(HAVE_LONG_64) || defined(HAVE_LONG_LONG_64)
+/* #ifdef HAVE_LONG_64 */
 static
-word64 * sh_tiger_hash_val (const char * filename, TigerType what, 
-			    UINT64 * Length, int timeout, word64 * res)
+word64 * sh_tiger_hash_val (char * filename, TigerType what, 
+			    unsigned long Length, int timeout)
 #else
 static
-sh_word32 * sh_tiger_hash_val (const char * filename, TigerType what, 
-			       UINT64 * Length, int timeout, sh_word32 * res)
+sh_word32 * sh_tiger_hash_val (char * filename, TigerType what, 
+			       unsigned long Length, int timeout)
 #endif
 {
   SL_TICKET  fd;
-  sh_string * content = NULL;
-  int  i, j, tt;
+  int  i, j;
   int  count = 0;
   int  blk;
   char    * tmp;
   sh_byte * bptr;
-  sh_byte   SH_GNUC_ALIGN8 bbuf[64];
-  UINT64    bcount = 0;
-
-  sh_byte * buffer = SH_ALLOC(PRIV_MAX + 72);
+  sh_byte buffer[PRIV_MAX + 72];
+  sh_byte bbuf[64];
 
   unsigned long pages_read;
@@ -147,13 +128,14 @@
 #endif
 
-#if defined(TIGER_64_BIT)
-#define TIGER_CAST (const word64*)
-  /* word64 res[3]; */
+#if defined(HAVE_LONG_64) || defined(HAVE_LONG_LONG_64)
+  /* #ifdef HAVE_LONG_64 */
+#define TIGER_CAST (word64*)
+  static word64 res[3];
   res[0]= (word64) 0x0123456789ABCDEFLL;
   res[1]= (word64) 0xFEDCBA9876543210LL;
   res[2]= (word64) 0xF096A5B4C3B2E187LL;
 #else
-#define TIGER_CAST (const sh_word32*)
-  /* sh_word32 res[6]; */
+#define TIGER_CAST (sh_word32*)
+  static sh_word32 res[6];
   res[0]= (sh_word32) 0x89ABCDEF;
   res[1]= (sh_word32) 0x01234567;
@@ -166,22 +148,21 @@
   SL_ENTER(_("sh_tiger_hash_val"));
 
-  if (what >= TIGER_FILE) 
-    {
-      if (what > TIGER_FILE)
+  if (what == TIGER_FILE || what == TIGER_FD) 
+    {
+      if (what == TIGER_FILE)
 	{
-	  fd      = what;
-	  content = sl_get_content(fd);
-	  TPT((0,FIL__, __LINE__, _("msg=<TIGER_FD>, fd=<%ld>\n"), fd));
+	  TPT((0,FIL__, __LINE__, _("msg=<TIGER_FILE>, path=<%s>\n"),
+	       (filename == NULL ? _("(null)") : filename) ));
+	  fd = sl_open_read (filename, SL_YESPRIV);
 	}
       else
 	{
-	  TPT((0,FIL__, __LINE__, _("msg=<TIGER_FILE>, path=<%s>\n"),
-	       (filename == NULL ? _("(null)") : filename) ));
-	  fd = sl_open_read (FIL__, __LINE__, filename, SL_YESPRIV);
+	  fd = tiger_fd;
+	  TPT((0,FIL__, __LINE__, _("msg=<TIGER_FD>, fd=<%ld>\n"), tiger_fd));
 	}
 
       if (SL_ISERROR (fd)) 
 	{
-	  TPT((0, FIL__, __LINE__, _("msg=<SL_ISERROR (%ld)>\n"), fd));
+	  TPT((0, FIL__, __LINE__, _("msg=<SL_ISERROR (%ld)>\n"), tiger_fd));
 	  tmp = sh_util_safe_name (filename);
 	  (void) sl_get_euid(&euid);
@@ -189,28 +170,16 @@
 			   MSG_E_ACCESS, (long) euid, tmp);
 	  SH_FREE(tmp);
-	  SH_FREE(buffer);
-	  *Length = 0;
 	  SL_RETURN( NULL, _("sh_tiger_hash_val"));
 	}
-
+      
 #if defined(HAVE_MLOCK) && !defined(HAVE_BROKEN_MLOCK)
-    if (skey->mlock_failed == S_FALSE) 
+    if (skey->mlock_failed == SL_FALSE) 
       {
-        if ( (-1) == sh_unix_mlock(FIL__, __LINE__, 
-				   (char *)buffer, 
-				   (PRIV_MAX)*sizeof(sh_byte))) 
-	  {
-	    SH_MUTEX_LOCK_UNSAFE(mutex_skey);  
-	    skey->mlock_failed = S_TRUE;
-	    SH_MUTEX_UNLOCK_UNSAFE(mutex_skey);
-	  }
+        if ( (-1) == sh_unix_mlock((char *)buffer,(PRIV_MAX)*sizeof(sh_byte))) 
+          skey->mlock_failed = SL_TRUE;
       }
 #else
-    if (skey->mlock_failed == S_FALSE)
-      {
-	SH_MUTEX_LOCK_UNSAFE(mutex_skey);  
-	skey->mlock_failed = S_TRUE;
-	SH_MUTEX_UNLOCK_UNSAFE(mutex_skey);
-      }
+    if (skey->mlock_failed == SL_FALSE)
+      skey->mlock_failed = SL_TRUE;
 #endif
 
@@ -221,8 +190,8 @@
     pages_read = 0;
 
-    while (1) 
+    while (1 == 1) 
       {
 	if (timeout > 0)
-	  count = sl_read_timeout (fd, buffer, PRIV_MAX, timeout, S_TRUE);
+	  count = sl_read_timeout (fd, buffer, PRIV_MAX, timeout);
 	else
 	  count = sl_read         (fd, buffer, PRIV_MAX);
@@ -232,10 +201,5 @@
 	if (SL_ISERROR (count)) 
 	  {
-	    int error = errno;
-
 	    if (sig_termfast == 1) {
-	      sh_unix_munlock((char *)buffer, (PRIV_MAX)*sizeof(sh_byte));
-	      SH_FREE(buffer);
-	      *Length = 0;
 	      SL_RETURN( NULL, _("sh_tiger_hash_val"));
 	    }
@@ -250,36 +214,12 @@
 	      }
 	    else
-	      {
-		char errbuf[SH_ERRBUF_SIZE];
-		char errbuf2[SH_ERRBUF_SIZE];
-		sl_strlcpy(errbuf, sl_error_string(count), sizeof(errbuf));
-		sh_error_message(error, errbuf2, sizeof(errbuf2));
-		sh_error_handle (ShDFLevel[SH_ERR_T_FILE], FIL__, __LINE__, 
-				 count, MSG_E_READ, errbuf, errbuf2, tmp);
-	      }
+	      sh_error_handle (ShDFLevel[SH_ERR_T_FILE], FIL__, __LINE__, 
+			       count, MSG_E_READ, tmp);
 	    SH_FREE(tmp);
-	    memset (bbuf,   0, 64);
-	    memset (buffer, 0, PRIV_MAX);
-
-	    sh_unix_munlock((char *)buffer, (PRIV_MAX)*sizeof(sh_byte));
-	    SH_FREE(buffer);
-	    *Length = 0;
+	    (void) sh_unix_munlock((char*)buffer, (PRIV_MAX)*sizeof(sh_byte));
 	    SL_RETURN( NULL, _("sh_tiger_hash_val"));
 	  }
 
-	if (content)
-	  sh_string_cat_lchar(content, (char*)buffer, count);
-
-	bcount += count;
-
-	if (*Length != TIGER_NOLIM)
-	  {
-	    if (bcount > *Length)
-	      {
-		count   = count - (bcount - (*Length));
-		bcount  = *Length;
-		count = (count < 0) ? 0 : count;
-	      }
-	  }
+	/* TPT((0, FIL__, __LINE__ , _("msg=<Read %ld bytes>\n"), count)); */
 
 	blk      = (count / 64); /* number of 64-byte words */
@@ -288,18 +228,14 @@
 	 * count cannot be negative here, see 'if (SL_ISERROR (count))'
 	 */
-	tt = blk*64;
-
-	ncount = (unsigned long) (count - tt);
-
-	nblocks += blk;
-	/* MAY_LOCK */
-	sh.statistics.bytes_hashed += tt;
+	ncount = (unsigned long) (count - ((count/64)*64));
 	
-	tt = 0;
+	bptr = buffer;
 	for (i = 0; i < blk; ++i)
 	  {
-	    bptr = &buffer[tt]; tt += 64;
+	    bptr = &buffer[64 * i];
 	    
 	    tiger_t(TIGER_CAST bptr, 64, res);
+	    ++nblocks;
+	    sh.statistics.bytes_hashed += 64;
 	    
 #ifdef TIGER_DBG
@@ -308,5 +244,5 @@
 	  }
 	
-	if (blk < (PRIV_MAX / 64)) /* this must be (PRIV_MAX / 64) */
+	if (blk < 64) /* this must be (PRIV_MAX / 64) */
 	  break;
 
@@ -316,7 +252,6 @@
 	    memset (bbuf,   0, 64);
 	    memset (buffer, 0, PRIV_MAX);
-	    sh_unix_munlock((char *)buffer, (PRIV_MAX)*sizeof(sh_byte));
-	    SH_FREE(buffer);
-	    *Length = 0;
+	    (void) sh_unix_munlock( (char *) buffer, 
+				    (PRIV_MAX) * sizeof(sh_byte));
 	    SL_RETURN( NULL, _("sh_tiger_hash_val"));
 	  }
@@ -333,12 +268,6 @@
     /* copy incomplete block
      */
-    j = 0; 
-    for (i = 0; i < 64; i += 4) 
-      {
-	bbuf[i]   = (sh_byte) '\0';
-	bbuf[i+1] = (sh_byte) '\0';
-	bbuf[i+2] = (sh_byte) '\0';
-	bbuf[i+3] = (sh_byte) '\0';
-      }
+    j = 0; for (i = 0; i < 64; ++i) 
+      bbuf[i] = (sh_byte) '\0';
     for (i = (count/64) * 64; i < count; ++i)
       /*@-usedef@*/bbuf[j++] = buffer[i];/*@+usedef@*/
@@ -373,10 +302,6 @@
 	  bbuf[j++] = (sh_byte) 0;
 	tiger_t(TIGER_CAST bbuf, 64, res);
-	/* MAY_LOCK */
 	sh.statistics.bytes_hashed += 64;
-	++nblocks; 
-#ifdef TIGER_DBG
-	ncount = 0;
-#endif
+	++nblocks; ncount = 0;
         memset(bbuf, 0, 56 ); 
       }
@@ -402,12 +327,15 @@
 #endif
 
-    memset (bbuf,   0, sizeof(bbuf));
-    memset (buffer, 0, sizeof(buffer));
+    memset (bbuf,   0, 64);
+    memset (buffer, 0, PRIV_MAX);
+
+    (void) sh_unix_munlock( (char *) buffer, (PRIV_MAX) * sizeof(sh_byte));
 
     if (what == TIGER_FILE)
       (void) sl_close (fd);
-    sh_unix_munlock((char *)buffer, (PRIV_MAX)*sizeof(sh_byte));
-    SH_FREE(buffer);
-    *Length = bcount;
+    else
+      tiger_fd = (-1);
+
+
     SL_RETURN( res, _("sh_tiger_hash_val"));
   }
@@ -415,12 +343,8 @@
   if (what == TIGER_DATA && filename != NULL) 
     {
-      tiger(TIGER_CAST filename, (sh_word32) *Length, res);
-      sh_unix_munlock((char *)buffer, (PRIV_MAX)*sizeof(sh_byte));
-      SH_FREE(buffer);
+      /* TPT((0, FIL__, __LINE__, _("msg=<TIGER_DATA>\n"))); */
+      tiger(TIGER_CAST filename,  (sh_word32) Length, res); 
       SL_RETURN(res, _("sh_tiger_hash_val"));
     }
-  sh_unix_munlock((char *)buffer, (PRIV_MAX)*sizeof(sh_byte));
-  SH_FREE(buffer);
-  *Length = 0;
   SL_RETURN( NULL, _("sh_tiger_hash_val"));
 }
